<?php
/*******************************************************************************/
//                          InstantCMS v1.10.1                                 //
//                      http://www.instantcms.ru/                              //                                                    //
//                  плагин "Похожие объявления" v.1.0.0                        //
//                        (p_more_adverts)                                     //
//                     written by Marat Fatikhov                               //
//                      (nickname Марат on a site)                             //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/********************************************************************************/
class p_more_adverts extends cmsPlugin {

//=============================================================================//


public function __construct(){

        parent::__construct();

        // Информация о плагине

        $this->info['plugin']           = 'p_more_adverts';
        $this->info['title']            = 'Похожие объявления';
        $this->info['description']      = 'Выводит похожие объявления при просмотре объявления';
        $this->info['author']           = 'Marat Fatikhov';
        $this->info['version']          = '1.0.0';        

        // Настройки по-умолчанию
        $this->config['Количество выводимых объявлений'] = 5;        
        
        // События, которые будут отлавливаться плагином

        $this->events[]                 = 'GET_BOARD_RECORD';       
    }

// ==================================================================== //

    /**
     * Процедура установки плагина
     * @return bool
     */
    public function install(){        

        return parent::install();

    }

// ==================================================================== //

    /**
     * Процедура обновления плагина
     * @return bool
     */
    public function upgrade(){               
         
        return parent::upgrade();

    }

// ==================================================================== //

     /**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event, $item){

        parent::execute();

        switch ($event){
            case 'GET_BOARD_RECORD': $item = $this->getMoreAdverts($item); break;            
        }

        return $item;

    }
    
    // ==================================================================== //
     private function getMoreAdverts($advert){
         
         $inDB = cmsDatabase::getInstance();
         
         $limit = $this->config['Количество выводимых объявлений'];
         $limit = ($limit != 0) ? (int)$limit : 5;
         
         $advert['more'] = '';
        
         //выборка из базы данных
         $sql = "SELECT id, obtype, title
                FROM `cms_board_items`
                WHERE id != '{$advert['id']}' AND 
                ((obtype = '{$advert['obtype']}' AND category_id = '{$advert['category_id']}') OR
                MATCH(content) AGAINST('{$advert['title']}'))
                ORDER BY id DESC
                LIMIT {$limit}";
              
          $rs = $inDB->query($sql);
          if(!$inDB->num_rows($rs)){ return $advert; }
          $advert['more'] = '<div class="con_heading" style="margin-top:25px;"><h3>Похожие объявления:</h3></div>';
          while ($item = $inDB->fetch_assoc($rs)){              
              $advert['more'] .= '<div style="font-size: 17px; line-height: 21px;">
                                    <a href="/board/read'.$item['id'].'.html">'.$item['obtype'].' '.$item['title'].'</a> 
                                    </div>';
          }
                                  
          return $advert;    
     }
    // ==================================================================== //     
     
}//class
?>
